﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
The CORE.JS file contains a set of core functions that are
not specificlly related to any one form.

NOTE: External dependencies should be avoided if at all 
      possible.
*/

// constants
var APP_NAME = "Clip Collector";
var APP_NAME_INSTALL = "ClipCollector.gadget";
var NAMESPACE = "Microsoft";
var SIDEBAR = "windows sidebar";
var DEFAULT_FLYOUT = "../html/flyout.html";

/*============================================================
FUNCTION:   changeButton ( string , string )
PARAMETERS: n (string) id of img element
            s (string) path to an image
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Changee the image elements src to the specified string
==============================================================*/
function changeButton(o, p)
{
    if(o.disabled=="")
        o.src=p;
}

/*============================================================
FUNCTION:   disableButton ( object )
PARAMETERS: o (object) an image (button)
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Disabled the image control - button.
==============================================================*/
function disableButton(o)
{
    o.disabled = "disabled";
    o.src = "../images/button-" + o.alt + "-disabled.png";
}

/*============================================================
FUNCTION:   enableButton ( object )
PARAMETERS: o (object) an image (button)
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Enabled the image control - button.
==============================================================*/
function enableButton(o)
{
    o.disabled = "";
    o.src = "../images/button-" + o.alt + "-default.png";
}

/*============================================================
FUNCTION:   setFocus ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Sets focus so the controls on the form are active.
==============================================================*/
function setFocus()
{
    setTimeout(getFocus, 300);
}

/*============================================================
FUNCTION:   getFocus ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Called by setFocus
==============================================================*/
function getFocus() 
{
    self.focus();
}

/*============================================================
FUNCTION:   initEvents ( object )
PARAMETERS: o (object) a document element
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
MODIFIED: 05/08/2007
DESCRIPTION:
Loop through the IMG elements in the document and all those
that are using the IMG-BUTTON class, add events to them so
that the following events make them dynamic buttons:
- onmouseover
- onmouseout
- onmousedown
- onmouseup
==============================================================*/
function initEvents(o)
{
    // get all th image elemets
    var imgs=o.getElementsByTagName("img");
    
    // loop though the images
    try {
        for(i=0;i<imgs.length;i++)
        {
            // if they are from the specified class
            if(imgs[i].className=="image-button")
            {
                // build the image paths...
                var a = imgs[i].alt;
                
                var std = "../images/button-" + a + "-default.png";
                var hvr = "../images/button-" + a + "-hover.png";
                var dwn = "../images/button-" + a + "-click.png";
                
                // apply the events
                imgs[i].onmouseover= new Function("changeButton(this,'" + hvr + "')");
                imgs[i].onmouseout= new Function("changeButton(this,'" + std + "')");
                imgs[i].onmousedown= new Function("changeButton(this,'" + dwn + "')");
                imgs[i].onmouseup= new Function("changeButton(this,'" + hvr + "')");
            }
        }
    } catch (err) {  }
}
