﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
The FLYOUT.JS file contains a set of core functions that are
specificlly related to the main.html file.

NOTE: External dependencies should be avoided if at all 
      possible.
*/

var displayClipNum = 1;
var clipCnt = 0;
var myCount = 0;

/*============================================================
FUNCTION:   setupGadget (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Arranges th controls on the form and initializes the form
level events for all items.
==============================================================*/
function setupGadget()
{
    setFocus();
    initEvents(document.body);
    
   with (clipData.style)
    {
        top="85px";
        left="30px";
    }
    
    with (previousButton.style)
    {
        top="350px";
        left="60px";
        visibility="";
    }
    
    with (copyButton.style)
    {
        top="350px";
        left="105px";
        visibility="";
    }    
    
    with (deleteButton.style)
    {
        top="350px";
        left="150px";
        visibility="";
    }
    
    with (nextButton.style)
    {
        top="350px";
        left="195px";
        visibility="";
    }
    
    with (countLabel.style)
    {
        top="55px";
        left="90px";
        visibility="";
    }
    
    with (notification.style)
    {
        top="45px";
        left="60px";
        visibility="";
    }
    
    initialize();
}

/*============================================================
FUNCTION:   initialize (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Load the settings and start the main loop.
==============================================================*/
function initialize()
{
    displayClipNum = System.Gadget.document.parentWindow.clipCnt;
    window.setTimeout("mainLoop()",1000);
}

/*============================================================
FUNCTION:   mainLoop (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
This is the core function for the gadget. Every 100ms this
event will fire. It will look at the clipboard and then
compare the data just pulled from the last data pulled. If
it is different, it will add it to the list of collected clips.

Aditionally, this loop serves to determine which buttons are
enabled and disabled, based on the status of clip count.
==============================================================*/
function mainLoop()
{
    clipCnt = System.Gadget.document.parentWindow.clipCnt;
    // BUTTON CONTOL --
    // Here is where buttons are enabled or disabled
    // based on the number of clips available and
    // which clip is currently being displayed
    if(clipCnt>1)
    {
        enableButton(deleteButton);
        enableButton(copyButton);
        
        if(displayClipNum == clipCnt)
        {
            enableButton(previousButton);
            disableButton(nextButton);
        }
        else if(displayClipNum == 1)
        {
            enableButton(nextButton);
            disableButton(previousButton);
        } 
        else
        {
            enableButton(nextButton);
            enableButton(previousButton);
        }
    } 
    else
    {
        // if nothing on clipboard at all, disable
        // the copy button
        if (clipCnt==0)
            disableButton(copyButton);
            
        // if only one clip in the collection 
        // disable all the buttons...
        disableButton(deleteButton);
        disableButton(previousButton);
        disableButton(nextButton);
    }
    
    // if the current clip is the one on the clipboard, then we
    // will disabled the copy button and notify the user...
    var currItem = System.Gadget.document.parentWindow.clips[displayClipNum];
    if(window.clipboardData.getData("Text")==currItem)
    {
        disableButton(copyButton);
        disableButton(deleteButton);
        notification.innerText="[CURRENTLY ON CLIPBOARD]";
    }
    else
    {
        notification.innerText="";
    }
    
    if (clipCnt >= 1)
    {
        loadClip();
    }
    else
    {
        // no clips = hide the clip window
        clipData.style.visibility = "hidden";
    }
}

/*============================================================
FUNCTION:   loadClip (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Load the current clip based on the displayClipNum global 
variable which can be changed by the previous and next buttons
and also can be modified by a delete action.
==============================================================*/
function loadClip()
{
    var item = new String(System.Gadget.document.parentWindow.clips[displayClipNum]);

    // load the clip into the display...
    clipData.style.visibility="";
    countLabel.innerText=displayClipNum + " of " + clipCnt;
    clipData.value=item;
}

/*============================================================
FUNCTION:   deleteButton_onclick (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Delete the selected clip and then move all the others up one
in the list, plus reduce the clipcount by one.
==============================================================*/
function deleteButton_onclick()
{
    try {
        // move all clips down...
        if(displayClipNum < clipCnt)
        {
            for(i=displayClipNum;i<clipCnt;i++)
            {
                System.Gadget.document.parentWindow.clips[i]=
                    System.Gadget.document.parentWindow.clips[i+1];
            }
        }
        clipCnt--;
        displayClipNum=clipCnt;
        System.Gadget.document.parentWindow.clipCnt = clipCnt;
    } catch (err) { }
    
    // return to loop
    mainLoop();
}

/*============================================================
FUNCTION:   copyButton_onclick (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Load the currently displayed clip to the clipboard, 
but set the previous and current values to the
new value so we avoid reloading it in the main loop
==============================================================*/
function copyButton_onclick()
{
    try {
        System.Gadget.document.parentWindow.previousClip = 
            System.Gadget.document.parentWindow.currentClip = 
            System.Gadget.document.parentWindow.clips[displayClipNum];
        window.clipboardData.setData("Text",System.Gadget.document.parentWindow.currentClip);
    } catch (err) { }
    
    disableButton(copyButton);
    mainLoop();
}

/*============================================================
FUNCTION:   previousButton_onclick (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Reduce the display counter by one so that in the main loop
the previous clip will be loaded.
==============================================================*/
function previousButton_onclick()
{
    displayClipNum--;
    mainLoop();
}

/*============================================================
FUNCTION:   nextButton_onclick (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Increase the display counter by one so that in the main loop
the next clip will be loaded.
==============================================================*/
function nextButton_onclick()
{
    displayClipNum++;
    mainLoop();
}